/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hadoop.chukwa.rest.objects;

// Generated May 28, 2009 3:39:53 PM by Hibernate Tools 3.2.4.GA

import java.sql.Timestamp;

/**
 * MrJobConf generated by hbm2java
 */
public class MrJobConf implements java.io.Serializable {
    static final long serialVersionUID = -4730316592827040570L;

    private String jobId;
    private Timestamp ts;
    private String mrOutputKeyCls;
    private String mrRunnerCls;
    private String mrOutputValueCls;
    private String mrInputFmtCls;
    private String mrOutputFmtCls;
    private String mrReducerCls;
    private String mrMapperCls;

    public MrJobConf() {
    }

    public MrJobConf(String jobId, Timestamp ts) {
	this.jobId = jobId;
	this.ts = ts;
    }

    public MrJobConf(String jobId, Timestamp ts, String mrOutputKeyCls,
		     String mrRunnerCls, String mrOutputValueCls, String mrInputFmtCls,
		     String mrOutputFmtCls, String mrReducerCls, String mrMapperCls) {
	this.jobId = jobId;
	this.ts = ts;
	this.mrOutputKeyCls = mrOutputKeyCls;
	this.mrRunnerCls = mrRunnerCls;
	this.mrOutputValueCls = mrOutputValueCls;
	this.mrInputFmtCls = mrInputFmtCls;
	this.mrOutputFmtCls = mrOutputFmtCls;
	this.mrReducerCls = mrReducerCls;
	this.mrMapperCls = mrMapperCls;
    }

    public String getJobId() {
	return this.jobId;
    }

    public void setJobId(String jobId) {
	this.jobId = jobId;
    }

    public Timestamp getTs() {
	return this.ts;
    }

    public void setTs(Timestamp ts) {
	this.ts = ts;
    }

    public String getMrOutputKeyCls() {
	return this.mrOutputKeyCls;
    }

    public void setMrOutputKeyCls(String mrOutputKeyCls) {
	this.mrOutputKeyCls = mrOutputKeyCls;
    }

    public String getMrRunnerCls() {
	return this.mrRunnerCls;
    }

    public void setMrRunnerCls(String mrRunnerCls) {
	this.mrRunnerCls = mrRunnerCls;
    }

    public String getMrOutputValueCls() {
	return this.mrOutputValueCls;
    }

    public void setMrOutputValueCls(String mrOutputValueCls) {
	this.mrOutputValueCls = mrOutputValueCls;
    }

    public String getMrInputFmtCls() {
	return this.mrInputFmtCls;
    }

    public void setMrInputFmtCls(String mrInputFmtCls) {
	this.mrInputFmtCls = mrInputFmtCls;
    }

    public String getMrOutputFmtCls() {
	return this.mrOutputFmtCls;
    }

    public void setMrOutputFmtCls(String mrOutputFmtCls) {
	this.mrOutputFmtCls = mrOutputFmtCls;
    }

    public String getMrReducerCls() {
	return this.mrReducerCls;
    }

    public void setMrReducerCls(String mrReducerCls) {
	this.mrReducerCls = mrReducerCls;
    }

    public String getMrMapperCls() {
	return this.mrMapperCls;
    }

    public void setMrMapperCls(String mrMapperCls) {
	this.mrMapperCls = mrMapperCls;
    }

}
